/************************************************************************************
Blackship RT-Component
Copyright (c) 2010, Segway-Japan, Ltd.
All rights reserved.

Contact us if you use this software for sell.
If you use this software not for sell, you can use this software under BSD lisence.
See the files LICENSE.TXT and LICENSE-BSD.TXT for more details.                     
************************************************************************************/
#ifndef __BS_IF_H__
#define __BS_IF_H__


class bs_status
{
 public:

  //status
  int int_left_wheel;
  int int_right_wheel;

  float battery_voltage;
  float ui_battery_voltage;

  //for internal use
  int int_left_prev;
  int int_right_prev;


  //odometory

  double wheelwidth;
  double wheelradiusL;
  double wheelradiusR;
  double count1rot;
  
  bool odofirst;

  double odox;
  double odoy;
  double odotheta;

  double addx;
  double addy;
  double addtheta;

  coil::TimeValue odotime;
  coil::TimeValue odotime_prev;

  bs_status()
  {
    memset(this, 0, sizeof(bs_status));
    odofirst = true;
  }
};


int blackship_open(char* serial_port);

int blackship_close(int fd);

int blackship_send_message(int fd, unsigned char *msg, int len);

int blackship_recv_message(int fd, unsigned char *msg, int num);

void blackship_get_encoder(int fd, int& le, int& re);
coil::TimeValue blackship_get_encoder2(int fd, int& le, int& re);

int blackship_set_speed(int fd, int ls, int rs);

int blackship_set_timeout(int fd, int tm);


#endif

